/*
* Copyright (C) 2003-2007 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// AnimatedIcon.cpp : implementation file
//

#include "stdafx.h"
#include "OutlookPlugin.h"
#include "AnimatedIcon.h"
#include "SyncForm.h"
#include "MainSyncFrm.h"

IMPLEMENT_DYNAMIC(CAnimatedIcon, CStatic)

CAnimatedIcon::CAnimatedIcon()
	: CStatic()
{
    counterAnim = 0;
    bMouseCaptured = false;
    brushHollow.CreateStockObject(HOLLOW_BRUSH);
    bmpBkDark.LoadBitmap(MAKEINTRESOURCE(IDB_BK_DARK));
}

CAnimatedIcon::~CAnimatedIcon()
{
}

void CAnimatedIcon::DoDataExchange(CDataExchange* pDX)
{
	CStatic::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CAnimatedIcon, CStatic)
    ON_WM_TIMER()
    ON_WM_PAINT()
    ON_WM_MOUSEMOVE()
    ON_MESSAGE(WM_MOUSELEAVE, OnMouseLeave)
END_MESSAGE_MAP()


// CAnimatedIcon message handlers

void CAnimatedIcon::OnTimer(UINT_PTR nIDEvent ){
    //this->SetIcon(NULL);

    if(counterAnim == 4)
        counterAnim = 0;
   /* switch(counterAnim){
        case 0:
            this->SetIcon(AfxGetApp()->LoadIcon(IDI_ARROWS32A));
             break;
        case 1:
            this->SetIcon(AfxGetApp()->LoadIcon(IDI_ARROWS32B));
            break;
        case 2:
            this->SetIcon(AfxGetApp()->LoadIcon(IDI_ARROWS32C)); 
            break;
        case 3:
            this->SetIcon(AfxGetApp()->LoadIcon(IDI_ARROWS32D));
            break;
    };
    */
    counterAnim++;
}


void CAnimatedIcon::Animate(){
    //SetIcon(::LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ARROWS32A)));
    //AnimateWindow(200,AW_VER_POSITIVE);
    state = STATE_ICON_SYNC;
    //this->SetTimer(ANIM_ICON_ARROWS, ANIM_ICON_DELAY, NULL);
}

void CAnimatedIcon::StopAnim(){
    state = STATE_DONE;
    KillTimer(ANIM_ICON_ARROWS);
}

void CAnimatedIcon::OnPaint(){
    // paint the icon, so it will be transparent over the background bitmap
    CPaintDC dc(this);


    if(state == STATE_BUTTON){
        CRect rect;
        GetClientRect(&rect);
        /*if( ((CMainSyncFrame*)AfxGetMainWnd())->bSyncStarted)
            ( (CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusSync.ShowWindow(SW_SHOW);
        else
       
            if(bMouseCaptured){
                // show sync icon in the right
                ( (CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusSync.ShowWindow(SW_SHOW);
            }
            else{
                ((CSyncForm*) ((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusSync.ShowWindow(SW_HIDE);
            }*/
       //};
    };
        
    dc.DrawIcon(0,0, GetIcon());
}


void CAnimatedIcon::OnMouseMove(UINT nFlags, CPoint point ){
    if(state != STATE_BUTTON){
        CStatic::OnMouseMove(nFlags, point);
        return;
    };

    if(! bMouseCaptured){
        TRACKMOUSEEVENT Tme;
        Tme.cbSize = sizeof(TRACKMOUSEEVENT);
        Tme.dwFlags = TME_LEAVE;
        Tme.hwndTrack = m_hWnd;
        int Result = TrackMouseEvent(&Tme); 

        bMouseCaptured = true;
        Invalidate();
    };    
    CStatic::OnMouseMove(nFlags, point);
}

LRESULT CAnimatedIcon::OnMouseLeave(WPARAM wParam, LPARAM lParam){
   // if(state != STATE_BUTTON)
     //   return 0;

    bMouseCaptured = false;
    Invalidate();
    return 0;
}