/*
* Copyright (C) 2003-2007 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "stdafx.h"
#include "OutlookPlugin.h"
#include "CustomPane.h"
#include "MainSyncFrm.h"
#include "SyncForm.h"
#include "winmaincpp.h"


IMPLEMENT_DYNAMIC(CCustomPane, CStatic)

CCustomPane::CCustomPane()
{
    bMouseCaptured = false;
    hPrevStatusIcon = NULL;
}

CCustomPane::~CCustomPane()
{
}

void CCustomPane::DoDataExchange(CDataExchange* pDX)
{
	CStatic::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CCustomPane, CStatic)
    ON_WM_MOUSEMOVE()
    ON_MESSAGE(WM_MOUSELEAVE, OnMouseLeave)
    ON_WM_PAINT()
END_MESSAGE_MAP()


// CCustomPane message handlers
void CCustomPane::OnMouseMove(UINT nFlags, CPoint point){
    if( (state == STATE_SYNC) || (state == STATE_PANE_DISABLED) )
        return;

    if(! bMouseCaptured){
        TRACKMOUSEEVENT Tme;
        Tme.cbSize = sizeof(TRACKMOUSEEVENT);
        Tme.dwFlags = TME_LEAVE;
        Tme.hwndTrack = m_hWnd;
        int Result = TrackMouseEvent(&Tme); 

    
            bMouseCaptured = true;
            /*CRect rect;
            GetClientRect(&rect);
            InvalidateRect(rect);
            UpdateWindow();*/

            
            if(type == PANE_TYPE_SYNC) {
                SetBitmap(LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_BK_DARK_BLUE)));
            }
            else {
                SetBitmap(LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_BK_BLUE)));
            }


            if(type == PANE_TYPE_CONTACTS){
                hPrevStatusIcon = ((CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusContacts.GetIcon();
                ((CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusContacts.SetIcon(AfxGetApp()->LoadIcon(IDI_SYNC_ALL));
                ((CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusContacts.ShowWindow(SW_SHOW);
            };

            if(type == PANE_TYPE_CALENDAR){
                 hPrevStatusIcon = ((CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusCalendar.GetIcon();
                ((CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusCalendar.SetIcon(AfxGetApp()->LoadIcon(IDI_SYNC_ALL));
                ((CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusCalendar.ShowWindow(SW_SHOW);
            };

            if(type == PANE_TYPE_TASKS){
                hPrevStatusIcon = ((CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusTasks.GetIcon();
                ((CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusTasks.SetIcon(AfxGetApp()->LoadIcon(IDI_SYNC_ALL));
                ((CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusTasks.ShowWindow(SW_SHOW);
            };

            if(type == PANE_TYPE_NOTES){
                hPrevStatusIcon = ((CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusNotes.GetIcon();
                ((CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusNotes.SetIcon(AfxGetApp()->LoadIcon(IDI_SYNC_ALL));
                ((CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusNotes.ShowWindow(SW_SHOW);
            };

            Invalidate();
        
    };    
    CStatic::OnMouseMove(nFlags, point);
}

void CCustomPane::OnPaint(){
    CPaintDC dc(this);
    CDC tempdc;
    tempdc.CreateCompatibleDC(&dc);
    CRect rect;
    GetClientRect(&rect);

    

    HBITMAP pOldBitmap = (HBITMAP) tempdc.SelectObject( GetBitmap() );

    dc.BitBlt(0,0, rect.Width(), rect.Height(), &tempdc,  0, 0, SRCCOPY);
    dc.SelectObject(pOldBitmap);

    if (type == PANE_TYPE_SYNC){

        if(bMouseCaptured) {
            // Mouse move: show blue arrows
            ((CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusSync.ShowWindow(SW_SHOW);
        }
        else {
            if( ((CMainSyncFrame*)AfxGetMainWnd())->bSyncStarted && !getConfig()->getScheduledSync() ) {
                // Sync started, not scheduled: show blue arrows
                ((CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusSync.ShowWindow(SW_SHOW);
            }
            else {
                // Sync not started or sched sync: hide blue arrows
                ((CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusSync.ShowWindow(SW_HIDE);
            }
        }
    }

    // update all stuff above it
   ( (CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->repaintPaneControls(type);

}

LRESULT CCustomPane::OnMouseLeave(WPARAM wParam, LPARAM lParam){

    if(bMouseCaptured){
        bMouseCaptured = false;


        if(type == PANE_TYPE_SYNC) {
            SetBitmap(LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_BK_DARK)));
        }
        else {
            SetBitmap(LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_BK_LIGHT)));
        }

        if( (type == PANE_TYPE_CONTACTS) && (state != STATE_SYNC) )
            ( (CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusContacts.SetIcon(hPrevStatusIcon);

        if( (type == PANE_TYPE_CALENDAR) && (state != STATE_SYNC) )
            ( (CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusCalendar.SetIcon(hPrevStatusIcon);

        if( (type == PANE_TYPE_TASKS) && (state != STATE_SYNC) )
            ( (CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusTasks.SetIcon(hPrevStatusIcon);

        if( (type == PANE_TYPE_NOTES) && (state != STATE_SYNC) )
            ( (CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->iconStatusNotes.SetIcon(hPrevStatusIcon);
    }
    
    // update all stuff above it
   ( (CSyncForm*)((CMainSyncFrame*)AfxGetMainWnd())->wndSplitter.GetPane(0,1))->repaintPaneControls(type);
    //Invalidate();
    return 0;
}