/*
 * Copyright (C) 2003-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "base/Log.h"
#include "event/OutlookSyncListener.h"
#include "HwndFunctions.h"

void OutlookSyncListener::syncBegin(SyncEvent &event) {
    LOG.info("\n ************************** BEGIN of Synchronization session **************************");
    SendMessage(HwndFunctions::getWindowHandle(), ID_MYMSG_SYNC_BEGIN, NULL, NULL);
}

void OutlookSyncListener::syncEnd(SyncEvent &event) {
    LOG.info("END of Synchronization session.");
    SendMessage(HwndFunctions::getWindowHandle(), ID_MYMSG_SYNC_END, NULL, NULL);
}

void OutlookSyncListener::sendInitialization( SyncEvent &event) {
    LOG.debug("Initialization sent.");
}

void OutlookSyncListener::sendModifications(SyncEvent &event) {
    LOG.debug("Modifications sent.");
}

void OutlookSyncListener::sendFinalization(SyncEvent &event) {
    LOG.debug("Finalization sent.");
}

void OutlookSyncListener::syncError(SyncEvent &event) {
    LOG.debug("Error occurred in sync: code %d = %s", event.getType(), event.getMessage());
}


