/*
* Copyright (C) 2003-2007 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef INCL_CLIENTNOTE
#define INCL_CLIENTNOTE


#include "outlook/defs.h"
#include "outlook/ClientItem.h"

#include <string>



///////////////////////////////////////////////////////////////////
class ClientNote : public ClientItem {

private:

    // Pointer to microsoft outlook objects.
    _NoteItemPtr     pNote;

    bool isSecureProperty (const std::wstring& propertyName);
    bool isComplexProperty(const std::wstring& propertyName);

    const std::wstring getSafeProperty   (const std::wstring& propertyName);
    const std::wstring getComplexProperty(const std::wstring& propertyName);

    int setComplexProperty(const std::wstring& propertyName, const std::wstring& propertyValue);

public:

    // Constructor
    ClientNote();
    ClientNote(const ClientNote& c);
    ClientNote operator=(const ClientNote& c);

    // Destructor
    ~ClientNote();


    // Set a COM pointer to this object: refresh all members.
    void setCOMPtr(_NoteItemPtr& ptr, const std::wstring& itemID);
    void setCOMPtr(_NoteItemPtr& ptr);


    //
    // Client operations on the item.
    //
    int saveItem();
    int deleteItem();
    ClientItem* copyItem();

};

#endif
