/*
 * Copyright (C) 2003-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef INCL_UTILS_OL
#define INCL_UTILS_OL


#include "base/fscapi.h"
#include "outlook/defs.h"
#include "winmaincpp.h"

#include <string>



// Item types conversions.
const OlDefaultFolders  getDefaultFolderType (const std::wstring& itemType);
const OlItemType        getOlItemType        (const std::wstring& itemType);
const std::wstring      getItemTypeFromOlType(const OlItemType olType);

void manageComErrors(_com_error &e);

const std::wstring getNameFromVersion  (std::wstring version);

// DATE/TIME conversions.
void doubleToSystemTime    (std::wstring& systemDate, const DATE doubleDate, const BOOL toUTC, const BOOL setHourToZero = FALSE);
void doubleToSystemTimeDate(std::wstring& systemDate, const DATE doubleDate);
void systemTimeDateToDouble(const std::wstring& dataString, DATE* date, WCHAR* type   = L"START");
void systemTimeToDouble    (const std::wstring& dataString, DATE* date, WCHAR* action = NULL);
bool isSystemTimeDate      (const std::wstring& dataString);

void localTimeToUTC(SYSTEMTIME &sysTime);
void UTCToLocalTime(SYSTEMTIME &sysTime);

// Boolean conversions.
BOOL         vBoolToBOOL(VARIANT_BOOL vbool);
VARIANT_BOOL BOOLToVBool(BOOL b);

#endif